istanbul-middleware-ry
===================
## Istanbul-middleware-ry is modified from istanbul-middleware
## istanbul-middleware-ry是由istanbul-middleware修改而来
## istanbul-middleware documentation can be found here
http://www.javascriptcn.com/post/50323
## istanbul-middleware 文档可参考
https://blog.csdn.net/heromps/article/details/109356164

### npm install it:

```
npm install istanbul-middleware -g
```
### npm安装方法
```
npm install istanbul-middleware -g
```
* npm address：https://www.npmjs.com/package/istanbul-middleware-ry
* Gitlab address：https://git.minrow.com/ry/istanbul-middleware-ry
* npm 地址：https://git.minrow.com/ry/istanbul-middleware-ry
* Gitlab 地址：https://git.minrow.com/ry/babel-plugin-ry-istanbul

## Add global command `coverage` description
| property                | explain                                                         | Other （The default wear and）    |
| ------------------- | ------------------------------------------------------------ | -------- |
| coverage -n  || coverage --nodemon | Start the view service command (nodemon listening service mode) | This command is a local debugging solution |
| coverage -s || coverage --serve | Start the view service command (pm2 listening service mode) | This command is a local debugging solution |
| coverage -c || coverage --close | Close the view service command | Used when a service port fails to close properly |
| coverage -h  || coverage --help | See how to use the command | without |
## 增加全局方法`coverage`
| 属性                | 说明                                                         | 其他 （默认穿参）    |
| ------------------- | ------------------------------------------------------------ | -------- |
| coverage -n  || coverage --nodemon | 启动查看服务命令(nodemon监听服务方式) | 此命令为本地调试方案 |
| coverage -s || coverage --serve | 启动查看服务命令(pm2监听服务方式) | 此命令为本地调试方案 |
| coverage -c || coverage --close | 关闭查看服务命令 | 当服务端口未能正常关闭时使用 |
| coverage -h  || coverage --help | 查看命令使用方法 | 无 |
## Passable arguments
| property                | explain                                                        | type    | default | other parameters |
| ------------------- | ------------------------------------------------------------ | -------- | ------ | ------ |
| IS_PITCHING_PILE | Whether or not to collect reported data for display. false does not collect data | string | true | true/false |
| FRACTION_OF_COVERAGE_PORT | Port number to start the service | string | 10000 | without |
## 可传入参数
| 属性                | 说明                                                         | 类型    | 默认值 | 其他参数 |
| ------------------- | ------------------------------------------------------------ | -------- | ------ | ------ |
| IS_PITCHING_PILE | 是否收集上报数据进行展示，false则不收集数据 | string | true | true/false |
| FRACTION_OF_COVERAGE_PORT | 启动服务时的端口号 | string | 10000 | 无 |
## Use method and delete interface description
### New usage methods
* New global order 'coverage - n' startup code coverage check service, provide code coverage check services, access: 'http://localhost:10000/coverage/client' can view, related command to view above.
* New global parameters`IS_PITCHING_PILE`(whether to display the reported data or not) and`FRACTION_OF_COVERAGE_PORT`(port number to start the service) are added. `coverage -n IS_PITCHING_PILE=true FRACTION_OF_COVERAGE_PORT=10001`
* To use the command, install pm2: `npm install pm2@5.2.0 -g --save-dev`
* It is recommended that `nyc` be installed in the project to collect instrumentation files：`npm install nyc --save-dev`
* `nyc` Configuration Using `vue` as an example, add an `nyc` object to `package.json` at the same level as `scripts`, as shown in the following code.
* Add nyc configuration to package.js：
```
{
    "script": {
        ......
    },
    "dependencies": {
        ......
    },
    "devDependencies": {
        ......
    },
    "nyc": {
        "include": [
            "html",
            "text-summary"
        ],
        "extension": [
            ".js",
            ".vue",
            ".jsx"
        ]
    }
}
```
### Cut the interface
* Remove the `GET /download` interface
## 使用方法和删减接口说明
### 新增使用方法
* 新增全局命令`coverage -n`启动代码覆盖率查看服务，提供代码覆盖率查看服务，访问：'http://localhost:10000/coverage/client’ 即可查看,相关命令可查看上方命令说明。
* 新增全局穿参`IS_PITCHING_PILE`（是否对上报数据进行展示）、`FRACTION_OF_COVERAGE_PORT`（启动服务的端口号），使用方法：`coverage -n IS_PITCHING_PILE=true FRACTION_OF_COVERAGE_PORT=10001`
* 使用命令前需在项目代码中安装pm2: `npm install pm2@5.2.0 -g --save-dev`
* 推荐项目中安装`nyc`用于收集插装文件：`npm install nyc --save-dev`
* `nyc`配置以`vue`为例，`package.json`中与`scripts`平级添加`nyc` 对象，如下代码所示。
* Add nyc configuration to package.js：
```
{
    "script": {
        ......
    },
    "dependencies": {
        ......
    },
    "devDependencies": {
        ......
    },
    "nyc": {
        "include": [
            "html",
            "text-summary"
        ],
        "extension": [
            ".js",
            ".vue",
            ".jsx"
        ]
    }
}
```
### 删减接口

* 删除 `GET /download`接口


## Description of New Features
* A new global command `coverage` is added to start or stop the coverage viewing service
1. Through the (`coverage - n | | coverage - nodemon`) or (`coverage -s || coverage --serve`) start the coverage checking service.
2. Through the `coverage - c | | coverage - close` close coverage checking service.
3. Through the `coverage - h | | coverage -- help` query service coverage
## 新增功能说明
* 新增全局命令`coverage`用于启动或关闭覆盖率查看服务
1. 通过（`coverage -n || coverage --nodemon`）或（`coverage -s || coverage --serve`）启动覆盖率查看服务。
2. 通过`coverage -c || coverage --close`关闭覆盖率查看服务。
3. 通过`coverage -h  || coverage --help`查询覆盖率服务执行命令

## ry-istanbul-web
* NPM address：https://www.npmjs.com/package/ry-istanbul-web
* GitLab address：https://git.minrow.com/ry/istanbul-web
* NPM地址：https://www.npmjs.com/package/ry-istanbul-web
* GitLab地址：https://git.minrow.com/ry/istanbul-web

* [ry-istok-web](https://www.npmjs.com/package/ry-istanbul-web) is modified from [istanbul](https://www.npmjs.com/package/istanbul), adding the changeLists array of window.__coverage__ for viewing the incremental code
* [ry-istok-web](https://www.npmjs.com/package/ry-istanbul-web)是由[istanbul](https://www.npmjs.com/package/istanbul)改装而来，增加window.__coverage__的changeLists数组用于查看增量代码

### babel-plugin-istanbul-ry
* NPM address：https://www.npmjs.com/package/babel-plugin-istanbul-ry
* GitLab address：https://git.minrow.com/ry/babel-plugin-ry-istanbul
* NPM地址：https://www.npmjs.com/package/babel-plugin-istanbul-ry
* GitLab地址：https://git.minrow.com/ry/babel-plugin-ry-istanbul

* [babel-plugin-istanbul-ry](https://www.npmjs.com/package/babel-plugin-istanbul-ry) bable instrumentation plugin is modified from [babel-plugin-istanbul](https://www.npmjs.com/package/babel-plugin-istanbul) to add incremental code instrumentation methods.

* [babel-plugin-istanbul-ry](https://www.npmjs.com/package/babel-plugin-istanbul-ry) bable插桩插件由[babel-plugin-istanbul](https://www.npmjs.com/package/babel-plugin-istanbul)改造而来，增加增量代码插桩方法。

### 0.0.7版本
增加报错兜底及服务
### 0.0.8版本
更新打包文件
